#include <stdio.h>
#include <string.h>

char SNP_name[2000][30], name1[30], name2[30], done_name[2000][30], undesirable_name[2000][30];
float SNP_weight[2000];
float SNP_MAF[2000];
long SNP_pos[2000];
float r2[2000][2000], r_value;
float max_ld = (float) 1.0;
long i, j, k, SNP_no, done_no, undesirable_total, undesirable_no[2000], need_total, need_no[2000];
long un_tag_total, un_tag_no[2000], undesirable_tag[2000], untag_total, un_tag_sum, tag_no[2000];
int status, untag[2000], un_tag_status[2000];
char un_tag_name[2000][30];
FILE *f1, *f2, *f3, *f4, *f5, *f6, *f7, *f8, *f9;

char new_name[2000][30];
float new_MAF[2000];
long new_pos[2000], new_no, current_row, current_col, un_tag_new[2000];
float new_r2[2000][2000];
char temp1[30], temp2[30], temp3[30];
long temp_pos, max_tag;
float temp_MAF;

void processing_undesirable()
{
	for ( i = 0; i < undesirable_total; i++ )
	{
		for ( j = 0; j < SNP_no; j++ )
		{
			if ( strcmp ( undesirable_name[i], SNP_name[j] ) == 0 )
			{
				undesirable_no[i] = j;
			}
		}
	}

	un_tag_total = 0;
	for ( i = 0; i < undesirable_total; i++ )
	{
		undesirable_tag[i] = 0;
		for ( j = 0; j < SNP_no; j++ )
		{
			status = 0;
			for ( k = 0; k < undesirable_total; k++ )
			{
				if ( j == undesirable_no[k] )
				{
					status = 1;
				}
			}
			if ( ( r2[j][undesirable_no[i]] >= max_ld ) && (status == 0 ) )
			{
				undesirable_tag[i]++;
			}
		}

		fprintf(f4, "Undesirable SNP %s is tagged by %ld other desirable SNPs\n" , undesirable_name[i], undesirable_tag[i]);
		if ( undesirable_tag[i] > 0 )
		{
			un_tag_no[un_tag_total] = undesirable_no[i];
			fprintf(f4, "Undesirable SNP %s can be tagged by other desirable SNPs\n", SNP_name[un_tag_no[un_tag_total]] );
			un_tag_total++;
		}
	}

	current_row = 0;
	for ( i = 0; i < undesirable_total; i++ )
	{
		if ( undesirable_tag[i] == 0 )
		{
			untag[undesirable_no[i]] = 1;
		}
		else
		{
			strcpy ( un_tag_name[current_row], undesirable_name[i] );
			current_row++;
		}
	}	

	untag_total = 0;
	for ( j = 0; j < SNP_no; j++ )
	{
		if ( untag[j] == 1 )
			untag_total++;
	}
	fprintf(f4, "Undesirable and untagged SNPs number: %ld\n", untag_total);

	for ( j = 0; j < un_tag_total; j++ )
	{
		fprintf(f4, "Undesirable and tagged SNP: %s\n", un_tag_name[j] );
	}

	new_no = SNP_no - untag_total;
	current_row = 0;
	for ( i = 0; i < SNP_no; i++ )
	{
		if ( untag[i] != 1 )
		{
			strcpy(new_name[current_row], SNP_name[i]);
			new_MAF[current_row] = SNP_MAF[i];
			new_pos[current_row] = SNP_pos[i];
			current_row++;
		}
	}

	current_row = 0;
	for ( i = 0; i < SNP_no; i++ )
	{
		current_col = 0;
		for ( j = 0; j < SNP_no; j++ )
		{
			if ( untag[i] != 1 && untag[j] != 1 )
			{
				new_r2[current_row][current_col] = r2[i][j];
				current_col++;
			}
		}
		if ( current_col > 0 )
		{
			current_row++;
		}
	}

	for ( i = 0; i < un_tag_total; i++ )
	{
		for ( j = 0; j < new_no; j++ )
		{
			if ( strcmp ( un_tag_name[i], new_name[j] ) == 0 )
			{
				un_tag_new[i] = j;
			}
		}
	}

	for ( i = 0; i < un_tag_total; i++ )
	{
		fprintf(f4, "The undesirable and tagged SNP %s is the %ldth SNP (counting from 0th) in the new table\n", un_tag_name[i], un_tag_new[i]);
	}

}  // processing_undesirable() end


void post_processing_undesirable()
{
	for ( i = 0; i < un_tag_total; i ++ )
	{
		for ( j = 0; j < new_no; j ++ )
		{
			new_r2[un_tag_new[i]][j] = 0;	
		}
	}

}	// post_processing_undesirable() end


void processing_need()
{
	need_total = 0;
	for ( i = 0; i < done_no; i++ )
	{
		for ( j = 0; j < new_no; j++ )
		{
			if ( strcmp ( done_name[i], new_name[j] ) == 0 )
			{
				need_no[i] = j;
			}
		}
	}
	need_total = need_total + done_no;

	for ( j = 0; j < un_tag_total; j++ )
	{
		un_tag_status[j] = 0;
	}

	for ( i = 0; i < need_total; i++ )
	{
		for ( j = 0; j < un_tag_total; j++ )
		{
			if ( new_r2[need_no[i]][un_tag_new[j]] >= max_ld )
			{
				un_tag_status[j] = 1;
			}
		}
	}

	un_tag_sum = 0;
	for ( j = 0; j < un_tag_total; j++ )
	{
		un_tag_sum = un_tag_sum + un_tag_status[j];
	}

	while ( un_tag_sum < un_tag_total )
	{
		for ( i = 0; i < new_no; i++ )
		{
			tag_no[i] = 0;
		}

		for ( i = 0; i < new_no; i++ )
		{
			for ( j = 0; j < un_tag_total; j++ )
			{
				if ( un_tag_status[j] == 0 && new_r2[i][un_tag_new[j]] >= max_ld )
				{
					tag_no[i]++;
				}
			}
		}

		max_tag = 0;
		for ( i = 1; i < new_no; i++ )
		{
			if ( tag_no[i] > tag_no[max_tag] )
				max_tag = i;
		}

		need_no[need_total] = max_tag;
		need_total++;

		for ( j = 0; j < un_tag_total; j++ )
		{
			if ( un_tag_status[j] == 0 && new_r2[max_tag][un_tag_new[j]] >= max_ld )
			{
				un_tag_status[j] = 1;
			}
		}

		un_tag_sum = 0;
		for ( j = 0; j < un_tag_total; j++ )
		{
			un_tag_sum = un_tag_sum + un_tag_status[j];
		}		

	}

	for ( i = 0; i < need_total; i++ )
	{
		fprintf(f4, "the %dth needed SNP (counting from 0) is: %s\n", i, new_name[need_no[i]] );
	}

}  // processing_need() end

void post_processing_need()
{
	for ( i = 0; i < need_total; i++ )
	{
		for ( k = 0; k < new_no; k++ )
		{
			new_r2[k][need_no[i]] = 0;
		}
		new_r2[need_no[i]][need_no[i]] = 1;
	}
}  // post_processing_need() end

void main()
{
	f1 = fopen("ld.txt", "r");
	f2 = fopen("maf.txt", "r");
	f3 = fopen("weight.txt", "r");
	f4 = fopen("ld_processed_temp.txt", "w");
	f5 = fopen("ld_processed.txt", "w");
	f6 = fopen("done.txt", "r");
	f7 = fopen("undesirable.txt", "r");
	f8 = fopen("maf_processed.txt", "w");
	f9 = fopen("SNP_names.data", "r");

	i = 0;
	fscanf(f9, "%s	%s	%s\n", temp1, temp2, temp3);
	while ( !feof(f9) )
	{
		fscanf(f9, "%s	%s\n", SNP_name[i], temp2);
		i++;
	}
	SNP_no = i;

	i = 0;
	while ( !feof(f2) )
	{
		fscanf(f2, "%s %ld %f\n", temp1, &temp_pos, &temp_MAF);
		if ( strcmp ( temp1, SNP_name[i] ) == 0 )
		{
			SNP_pos[i] = temp_pos;
			SNP_MAF[i] = temp_MAF;
			i++;
		}
	}
	fclose(f2);

	i = 0;
    while ( !feof(f3) )
	{
		fscanf(f3, "%s	%f\n", SNP_name[i], &SNP_weight[i]);
		i++;
	}
	fclose(f3);

	i = 0;
	while ( !feof(f6) )
	{
		fscanf(f6, "%s\n", done_name[i]);
		i++;
	}
	done_no = i;
	fclose(f6);
	if ( done_no == 1 && strcmp ( done_name[0], "" ) == 0 )
	{
		done_no = 0;
	}
	fprintf(f4, "total done SNP number is %ld\n", done_no);

	i = 0;
	while ( !feof(f7) )
	{
		fscanf(f7, "%s\n", undesirable_name[i]);
		i++;
	}
	undesirable_total = i;
	fclose(f7);
	if ( undesirable_total == 1 && strcmp ( undesirable_name[0], "" ) == 0 )
	{
		undesirable_total = 0;
	}
	fprintf(f4, "undesirable SNPs total number is %ld\n", undesirable_total);

	i = 0; j = 1;
	for ( i = 0; i < SNP_no; i++ )
		{
			for ( j = i; j < SNP_no; j++ )
			{
				r2[i][j] = 0;
			}
	}

	while ( !feof(f1) )
	{
		fscanf(f1, "%s %s %f\n", name1, name2, &r_value);
		
		for ( i = 0; i < SNP_no; i++ )
		{
			for ( j = i; j < SNP_no; j++ )
			{
				if ( ( strcmp ( name1, SNP_name[i] ) == 0 ) && ( strcmp ( name2, SNP_name[j] ) == 0 ) )
				{
					r2[i][j] = r_value;
				}
			}
		}
		
/*		if ( strcmp ( name1, SNP_name[i] ) == 0 )
		{
			if ( strcmp ( name2, SNP_name[j] ) == 0 )
			{
				r2[i][j] = r_value;
				j++;
				if ( j == SNP_no )
				{
					i++;
					j = i + 1;
				}
			}
		}
*/

	}
	fclose(f1);

	
	for ( i = 0; i < SNP_no; i++ )
	{
		r2[i][i] = 1;
	}

	for	( i = 0; i < SNP_no; i++ )
	{
		for ( j = i + 1; j < SNP_no; j++ )
		{
			r2[j][i] = r2[i][j];
		}
	}


	for ( i = 0; i < SNP_no; i++ )
	{
		for ( j = 0; j < SNP_no; j++ )
		{
			if ( i != j )
			{
				r2[i][j] = max_ld - ( SNP_weight[j] - r2[i][j] );
			}
		}
	}

	processing_undesirable();
	post_processing_undesirable();
	processing_need ();
	post_processing_need();


	fprintf(f4, "\n  Before deleting undesirable and untagged SNPs, and adjusting the weights for done and undersirable SNPs: r2 table:\n");
	for ( i = 0; i < SNP_no; i++ )
	{
		for ( j = 0; j < SNP_no; j++ )
		{
			fprintf(f4, "%f ", r2[i][j]);
		}
		fprintf(f4, "\n");
	}
	fprintf(f4, "\n  After deleting and adjusting for done SNPs: new_r2 table:\n");
	for ( i = 0; i < new_no; i++ )
	{
		for ( j = 0; j < new_no; j++ )
		{
			fprintf(f4, "%f ", new_r2[i][j]);
		}
		fprintf(f4, "\n");
	}
	fclose(f4);
	
	for ( i = 0; i < new_no; i++ )
	{
		for ( j = 0; j < new_no; j++ )
		{
			fprintf(f5, "%s %s %f\n", new_name[i], new_name[j], new_r2[i][j]);
		}
	}
	fclose(f5);

	for ( i = 0; i < new_no; i++ )
	{
		fprintf(f8, "%s %ld %f\n", new_name[i], new_pos[i], new_MAF[i]);
	}
	fclose(f8);

}